#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "saol_prec.h"
#include "bifs_nums.h"
#include "bifs_nodes.h"
#include "saol.h"
#include "aifif.h"
#include "ac.h"
/*#include "saol_sched.h"


extern void resample(sa_decoder *sa, sa_real **old, sa_real ***last, sa_real **new, int oldct, int newct, int nchan, int q);

// in bifs_init.c
extern set_field_positions();
*/

/* in ba.c 
extern long unpack();
extern long bit();
*/

/* void traverse(struct mpeg4_node *n); */
struct mpeg4_node *top = NULL;
int nodenum = 0;
double maxframetime;

AIF_STRUCT *aifout;

double ac_time = 0;
double alldone = 0;
double ac_frame_time = 0.1;
comp_buffer *cb = NULL;
decoder *decoders;
double max_decoder_time = 0, min_decoder_time = 0;

void output(mpeg4_node *n) {
  static int first = 1;
  int i,j;
  static short *outbuf;
  long pvb[16];
  int pvl = 0,chanct=0,ct;
  
  if (first) {
    outbuf = (short *)calloc(framesize(n)*n->outchan,sizeof(short));

    aifout = aifNew();
    pvb[pvl++] = AIF_P_SAMPRATE;  pvb[pvl++] = n->srate;
    pvb[pvl++] = AIF_P_CHANNELS;  pvb[pvl++] = n->outchan;
    pvb[pvl++] = AIF_P_SAMPSIZE;  pvb[pvl++] = 16;
    pvb[pvl++] = AIF_P_FILETYPE;  pvb[pvl++] = AIF_FT_AIFF;
    aifSetParams(aifout,pvb,pvl);
    aifOpenWrite(aifout,"ac.aiff",UNK_LEN);

    first = 0;
  }

  ct = 0;
  for (i=0;i!=framesize(n);i++)
    for (j=0;j!=n->outchan;j++) 
      outbuf[ct++] = (short)(n->outbuf[j][i] * 32767);

  aifWriteFrames(aifout,outbuf,framesize(n));
  free_buf(n->outbuf,n->outchan);

}

void detokenize_orc(char *tok,char *fn) {
  int i;
  FILE *fp;

  if (!(fp = fopen(fn,"w"))) {
    printf("Couldn't open '%s' for write.\n",fn);
    exit(1);
  }
  for (i=0;i!=strlen(tok);i++)
    fputc(tok[i],fp);
  fclose(fp);
}

void detokenize_sco(char *tok,char *fn) {
  int i;
  FILE *fp;

  if (!(fp = fopen(fn,"w"))) {
    printf("Couldn't open '%s' for write.\n",fn);
    exit(1);
  }
  for (i=0;i!=strlen(tok);i++)
    fputc(tok[i],fp);
  fclose(fp);
}

void startup_ac(mpeg4_node *node) {
  char s[1000],s2[200];
  double delay;
  int which,i,j,ct,ct2;
  FILE *fp;
  char orchname[80];
  char scorename[80];
  struct cmdinfo cmd;
  int ksmps;
  static int orcct = 0, scoct = 0;
  comp_buffer *cu;
  decoder *tempDecoder;
  decoder *purgeDecoder;
  int tempStart = 0, tempLength = 0, tempStart2 = 0;
  sa_real **tempBuf;

  switch (node->type) {

  case AudioBuffer_Node: {
    struct AudioBuffer *n = (struct AudioBuffer *)node;

    /* make a cache for old input data (needed for resampling) */
    n->inbuf_last = (sa_real ***)calloc(n->num_children,sizeof(sa_real **));
  
    for (i=0;i!=n->num_children;i++) {
      startup_ac(n->children[i]);
      if (n->children[i]->srate > n->srate)
      	n->srate = n->children[i]->srate;
      n->inchan += n->children[i]->outchan;
    }

    n->outchan = n->inchan;
    n->inbuf = buffer(n->inchan,framesize((mpeg4_node *)n));
//    n->clipbuf = buffer(n->outchan, n->length * n->srate * abs(n->pitch));
  }
  break;

  case AudioClip_Node: {
    struct AudioClip *n = (struct AudioClip *)node;

    /* make a cache for old input data (needed for resampling) */
    n->inbuf_last = (sa_real ***)calloc(1,sizeof(sa_real **));

		/* make a temporary decoder to load the audio clip */
    n->decoder = new_decoder(get_decoder_type(n->url[0]));
    n->decoder->startup(n->decoder,n->url[0]);
    n->decoder->node = (mpeg4_node *)n;
    n->outchan = n->decoder->outchan;
    n->srate = n->decoder->srate;
//    if (tempDecoder->frame > maxframetime)
//  		maxframetime = n->decoder->frame;

		tempLength = (n->stopTime-n->startTime)*n->srate*abs(n->pitch);
    n->clipbuf = buffer(n->outchan, tempLength);

		if (!n->loop)
	    while ((!n->decoder->done) && (tempStart < tempLength)) {
	    	cu = (*n->decoder->run_frame)(n->decoder, NULL);
	    	if (tempStart + cu->length >= tempLength)
	    		cu->length = tempLength - tempStart;
	    	if (n->pitch > 0)	
					add_buf(cu->buf, n->clipbuf, cu->length, &tempStart, n->outchan);
				else {
					/* need to reverse the clip */
					tempBuf = buffer(n->outchan,cu->length);
					for (i=0;i<n->outchan;i++)
						for (j=0;j<cu->length;j++)
							tempBuf[i][j] = cu->buf[i][cu->length-j-1];
					tempStart2 = tempLength - tempStart - cu->length - 1;
					add_buf(tempBuf, n->clipbuf, cu->length, &tempStart2, n->outchan);
					tempStart += cu->length;
					free_buf(tempBuf,n->outchan);
				}
	      if (!cu)
					n->decoder->time += n->decoder->frame;
	      else
					n->decoder->time =  cu->time + cu->length/(double)n->decoder->srate;
				free(cu->buf);
			}
		else
	    while (tempStart < tempLength) {
	    	if (n->decoder->done) {
	    	/* End of clip.  Must loop, so free old decoder, begin again with new one. */
					decoders = n->decoder->next;
					free(n->decoder);
			    n->decoder = new_decoder(get_decoder_type(n->url[0]));
			    n->decoder->startup(n->decoder,n->url[0]);
			    n->decoder->node = (mpeg4_node *)n;
	    	}
	    	cu = (*n->decoder->run_frame)(n->decoder, NULL);
				if (cu) {
		    	if (tempStart + cu->length >= tempLength)
		    		cu->length = tempLength - tempStart;
		    	if (n->pitch > 0)
						add_buf(cu->buf, n->clipbuf, cu->length, &tempStart, n->outchan);
					else {
						/* need to reverse the clip */
						tempBuf = buffer(n->outchan,cu->length);
						for (i=0;i<n->outchan;i++)
							for (j=0;j<cu->length;j++)
								tempBuf[i][j] = cu->buf[i][cu->length-j-1];
						tempStart2 = tempLength - tempStart - cu->length - 1;
						add_buf(tempBuf, n->clipbuf, cu->length, &tempStart2, n->outchan);
						tempStart += cu->length;
						free_buf(tempBuf,n->outchan);
					}
					n->decoder->time =  cu->time + cu->length/(double)n->decoder->srate;
					free(cu->buf);
				}
			}

		n->decoder->time = n->stopTime;
		n->decoder->done = TRUE;
		min_decoder_time = n->stopTime;

		free(cu);
		cb = NULL;
  }
  break;

  case AudioDelay_Node: {
    struct AudioDelay *n = (struct AudioDelay *)node;

    /* make a cache for old input data (needed for resampling) */
    n->inbuf_last = (sa_real ***)calloc(n->num_children,sizeof(sa_real **));
  
    for (i=0;i!=n->num_children;i++) {
      startup_ac(n->children[i]);
      if (n->children[i]->srate > n->srate)
      	n->srate = n->children[i]->srate;
      n->inchan += n->children[i]->outchan;
    }

    n->outchan = n->inchan;
    n->inbuf = buffer(n->inchan,framesize((mpeg4_node *)n));

    /* the buffer for the delay */
    n->delbuf = buffer(n->inchan,n->srate * n->delay);
  }
  break;

  case AudioFX_Node: {
    struct AudioFX *n = (struct AudioFX *)node;

    /* we make a new "decoder" which isn't really a decoder but
       a transform.  The SA decoder does both.  The 'cmdinfo'
       structure is all the control information needed to startup
       the FX SA process.  */

    /* initialize the structure */
	cmd.sco = cmd.orc = cmd.out = cmd.midi = NULL;
    cmd.sfbank0 = cmd.sfbank1 = 0;
	cmd.decoder = NULL;
    cmd.inct = 0;
    cmd.insr = 0;
    cmd.text = 0;
    cmd.verbose = 0;
	cmd.has_midi = cmd.has_sco = cmd.has_sbf = 0;
	cmd.interp = 5;
    cmd.bit = NULL;
    cmd.temp = ".";
    cmd.sco = NULL;
	cmd.midi = 0;
	cmd.southpark = 0;
	cmd.segfault = 0;

    /* make a cache for old input data (needed for resampling) */

    n->inbuf_last = (sa_real ***)calloc(n->num_children,sizeof(sa_real **));
    n->inchan = 0;
    for (i=0;i!=n->num_children;i++) {
      /* start up each child */
      startup_ac(n->children[i]);
      /* clear the data cache */
      n->inbuf_last[i] = NULL;
      /* tally up the number of input channels */
      cmd.inct = n->inchan += n->children[i]->outchan;
      /* keep track of the fastest input SR */
      if (cmd.insr < n->children[i]->srate) cmd.insr = n->children[i]->srate;
    }

    /* detokenize and dump out orch */

//	Test change 1/25/2000
//    sprintf(orchname,"FX%d.saol",orcct++);
	orcct++;
//    detokenize_orc(n->orch,orchname);
//    cmd.orc = orchname;
	cmd.orc = strdup(n->orch);

    /* detokenize and dump out score */
    if (n->score) {
      sprintf(scorename,"FX%d.sasl",scoct++);
      detokenize_sco(n->score,scorename); 
      cmd.sco = scorename;
    }

    /* can't use new_decoder because it's not a decoder! */
    
    n->decoder = (decoder *)malloc(sizeof(decoder));
    n->decoder->type = SA;
    n->decoder->node = (mpeg4_node *)n;
    n->decoder->priv = (void *)malloc(sizeof(sa_decoder));
    cmd.decoder = n->decoder;
    saol_startup(n->decoder->priv,&cmd);
    
    n->outchan = ((sa_decoder *)n->decoder->priv)->all->g->outchan;
    n->srate = ((sa_decoder *)n->decoder->priv)->all->g->srate;
    n->inbuf = buffer(n->inchan,framesize((mpeg4_node *)n));
    ksmps = ((sa_decoder *)n->decoder->priv)->ksmps;
    n->fxinbuf = buffer(n->inchan,framesize((mpeg4_node *)n)+ksmps);
    n->fxoutbuf = buffer(n->outchan,framesize((mpeg4_node *)n)+ksmps);
    n->fxinpt = n->fxoutpt = 0;

	// For some reason (?), these aren't initialized properly above
	cmd.decoder->outchan = n->outchan;
	cmd.decoder->srate = n->srate;
    
  }
  break;
    
  case AudioSource_Node: {
    struct AudioSource *n = (struct AudioSource *)node;

    n->decoder = new_decoder(get_decoder_type(n->url[0]));
    n->decoder->startup(n->decoder,n->url[0]);
    n->decoder->node = (mpeg4_node *)n;
    n->outchan = n->decoder->outchan;
    n->srate = n->decoder->srate;
    if (n->decoder->frame > maxframetime) maxframetime = n->decoder->frame;
  }
  break;

  case AudioMix_Node: {
    struct AudioMix *n = (struct AudioMix *)node;

    /* make a cache for old input data (needed for resampling) */
    n->inbuf_last = (sa_real ***)calloc(n->num_children,sizeof(sa_real **));
    n->inchan = 0;
    
    for (i=0;i!=n->num_children;i++) {
      startup_ac(n->children[i]);
      if (n->children[i]->srate > n->srate) n->srate = n->children[i]->srate;
      n->inchan += n->children[i]->outchan;
      n->inbuf_last[i] = NULL;
    }

    n->outchan = n->numChan;
    n->inbuf = buffer(n->inchan,framesize((mpeg4_node *)n));
  }
  break;

  case AudioSwitch_Node: {
    struct AudioSwitch *n = (struct AudioSwitch *)node;

    /* make a cache for old input data (needed for resampling) */
    n->inbuf_last = (sa_real ***)calloc(n->num_children,sizeof(sa_real **));
		n->inchan = 0;
  
    for (i=0;i!=n->num_children;i++) {
      startup_ac(n->children[i]);
      if (n->children[i]->srate > n->srate)
      	n->srate = n->children[i]->srate;
      n->inchan += n->children[i]->outchan;
    }

    n->outchan = n->numChan;
		n->inbuf = buffer(n->inchan,framesize((mpeg4_node *)n));
  }
  break;

  case Group_Node: {
   struct Group *n = (struct Group *)node;
   
   /* Group is just AudioMix with equal mixing levels */
   n->inbuf_last = (sa_real ***)calloc(n->num_children,sizeof(sa_real **));
   
   for (i=0;i!=n->num_children;i++) {
     startup_ac(n->children[i]);
     if (n->children[i]->srate > n->srate) n->srate = n->children[i]->srate;
     n->inchan += n->children[i]->outchan;
     n->inbuf_last[i] = NULL;
   }
   
   n->outchan = MIN(2,n->inchan);
   n->inbuf = buffer(n->inchan,framesize((mpeg4_node *)n));
  }
  break;

  case Layer2D_Node: {
   struct Layer2D *n = (struct Layer2D *)node;
   
   /* Layer2D is just AudioMix with equal mixing levels */
   n->inbuf_last = (sa_real ***)calloc(n->num_children,sizeof(sa_real **));
   
   for (i=0;i!=n->num_children;i++) {
     startup_ac(n->children[i]);
     if (n->children[i]->srate > n->srate) n->srate = n->children[i]->srate;
     n->inchan += n->children[i]->outchan;
     n->inbuf_last[i] = NULL;
   }
   
   n->outchan = MIN(2,n->inchan);
   n->inbuf = buffer(n->inchan,framesize((mpeg4_node *)n));
  }
  break;

  case Sound2D_Node: {
    struct Sound2D *n = (struct Sound2D *)node;
    
    /* Sound2D passes through here */
    startup_ac(n->source);
    n->inchan = n->source->outchan;
    n->outchan = n->inchan;
    n->srate = n->source->srate;
  }
  break;

  }
}
  

void ac_run(mpeg4_node *top) {
#ifdef _DEBUG
  printf("ac.c:ac_run()\n");
#endif
  ac_time = ac_time + ac_frame_time;
  ac_traverse(top);
  output(top);
}

int framesize(mpeg4_node *n) {
  return (int)(n->srate * ac_frame_time + 0.5);
}

void ac_traverse(mpeg4_node *node) {
  int i,j,ct=0,k;
  int ksmps;
	int delay;
	int tempLength, tempStart;
	double tempDecoderTime;
	long tempSampleRate;
	sa_real **tempClipBuf;

  switch (node->type) {

  case AudioSource_Node: {
    struct AudioSource *n = (struct AudioSource *)node;
    
    n->outbuf = buffer(n->outchan,framesize((mpeg4_node *)n));
    get_decoder_samples(n->decoder,n->outbuf,ac_time);
  }
  break;


  case AudioBuffer_Node: {
    struct AudioBuffer *n = (struct AudioBuffer *)node;
    
    n->outbuf = buffer(n->outchan,framesize((mpeg4_node *)n));

    for (i=0;i!=n->num_children;i++) {
      ac_traverse(n->children[i]);
      resample(NULL,(float **)(n->children[i]->outbuf),(float ***)(&n->inbuf_last[i]),(sa_real **)(&n->inbuf[ct]),
	       framesize(n->children[i]),framesize((mpeg4_node *)n),
	       n->children[i]->outchan,8);
      ct += n->children[i]->outchan;
    }

//    clear_buf(n->outbuf,n->outchan,framesize((mpeg4_node *)n));

//	if (n->isActive)
//		memcpy(n->outbuf, n->inbuf, framesize((mpeg4_node *)n)*sizeof(sa_real));
  }
  break;


  case AudioClip_Node: {
    struct AudioClip *n = (struct AudioClip *)node;
    
    n->inbuf = buffer(n->outchan,framesize((mpeg4_node *)n) * abs(n->pitch));
    n->outbuf = buffer(n->outchan,framesize((mpeg4_node *)n));

		if ( (ac_time >= n->startTime) && (ac_time < n->stopTime) ) {
			n->isActive = TRUE;
			if (ac_time - n->startTime > ac_frame_time)
				tempStart = 0;			
			else
				/* First frame, so need to write data at the right time within the frame */
				tempStart = (n->startTime - (ac_time - ac_frame_time)) * n->srate * abs(n->pitch);
			tempLength = framesize((mpeg4_node *)n) * abs(n->pitch);
		}
		else if ( abs(ac_time - n->stopTime) < ac_frame_time)	{
			/* last frame of clip */
			n->isActive = TRUE;
			tempStart = 0;
			tempLength = (ac_time - n->stopTime) * n->srate * abs(n->pitch);
		}
		else
			n->isActive = FALSE;

		if (n->isActive) {				
	    for (i=0;i!=n->outchan;i++)
	      for (j=tempStart;j<tempLength;j++)
					n->inbuf[i][j] += n->clipbuf[i][j-tempStart+n->offset];
      resample(NULL,(float **)(n->inbuf),(float ***)(&n->inbuf_last[0]),(sa_real **)(&n->outbuf[0]),
		       framesize((mpeg4_node *)n) * abs(n->pitch),framesize((mpeg4_node *)n),
		       n->outchan,8);
		  n->offset += tempLength - tempStart;
  	}
  	
//  	free_buf(n->inbuf,n->outchan);
  }
  break;
  
  case AudioDelay_Node: {
    struct AudioDelay *n = (struct AudioDelay *)node;
    
    n->outbuf = buffer(n->outchan,framesize((mpeg4_node *)n));
    
    for (i=0;i!=n->num_children;i++) {
      ac_traverse(n->children[i]);
      resample(NULL,(float **)(n->children[i]->outbuf),(float ***)(&n->inbuf_last[i]),(sa_real **)(&n->inbuf[ct]),
	       framesize(n->children[i]),framesize((mpeg4_node *)n),
	       n->children[i]->outchan,8);
      ct += n->children[i]->outchan;
    }

    clear_buf(n->outbuf,n->outchan,framesize((mpeg4_node *)n));

		delay = n->srate * n->delay;
    
		if (delay < framesize((mpeg4_node *)n))	// delay buffer smaller than framesize
    {
	    for (i=0;i!=n->outchan;i++)
	      for (j=0;j<delay;j++)
					n->outbuf[i][j] += n->delbuf[i][j];

	    clear_buf(n->delbuf,n->outchan,delay);

	    for (i=0;i!=n->outchan;i++)
	      for (j=delay;j!=framesize((mpeg4_node *)n);j++)
					n->outbuf[i][j] += n->inbuf[i][j-delay] / n->inchan;

	    for (i=0;i!=n->outchan;i++)
	      for (j=0;j<delay;j++)
					n->delbuf[i][j] += n->inbuf[i][j+framesize((mpeg4_node *)n)-delay] / n->inchan;					
    }
    else if (delay > framesize((mpeg4_node *)n))		// delay buffer larger than framesize
    {
	    for (i=0;i!=n->outchan;i++)
	      for (j=0;j!=framesize((mpeg4_node *)n);j++)
					n->outbuf[i][j] += n->delbuf[i][j] / n->inchan;

			tempLength = delay;
			shift_buf(n->delbuf, &tempLength, framesize((mpeg4_node *)n), n->outchan);
			
			tempStart = delay - framesize((mpeg4_node *)n);
			add_buf(n->inbuf, n->delbuf, framesize((mpeg4_node *)n), &tempStart, n->outchan);
    }
    else	// delay buffer and framesize are the same
    {
	    for (i=0;i!=n->outchan;i++)
	      for (j=0;j!=framesize((mpeg4_node *)n);j++)
					n->outbuf[i][j] += n->delbuf[i][j];

	    clear_buf(n->delbuf,n->outchan,delay);

	    for (i=0;i!=n->outchan;i++)
	      for (j=0;j!=framesize((mpeg4_node *)n);j++)
					n->delbuf[i][j] += n->inbuf[i][j] / n->inchan;
    }
	}
  break;



  case AudioMix_Node: {
    struct AudioMix *n = (struct AudioMix *)node;
    
    n->outbuf = buffer(n->outchan,framesize((mpeg4_node *)n));
    
    for (i=0;i!=n->num_children;i++) {
      ac_traverse(n->children[i]);
      resample(NULL,(float **)(n->children[i]->outbuf),(float ***)(&n->inbuf_last[i]),(sa_real **)(&n->inbuf[ct]),
	       framesize(n->children[i]),framesize((mpeg4_node *)n),
	       n->children[i]->outchan,8);
      ct += n->children[i]->outchan;
    }

    clear_buf(n->outbuf,n->outchan,framesize((mpeg4_node *)n));

    ct = 0;
    
    for (k=0;k!=n->numInputs;k++)
      for (i=0;i!=n->numChan;i++) {
	for (j=0;j!=framesize((mpeg4_node *)n);j++)
	  n->outbuf[i][j] += n->inbuf[k][j] * n->matrix[ct];
	ct++;
      }
    
  }
  break;
  

  case AudioSwitch_Node: {
    struct AudioSwitch *n = (struct AudioSwitch *)node;
    
    n->outbuf = buffer(n->outchan,framesize((mpeg4_node *)n));
    
    for (i=0;i!=n->num_children;i++) {
      ac_traverse(n->children[i]);
      resample(NULL,(float **)(n->children[i]->outbuf),(float ***)(&n->inbuf_last[i]),(sa_real **)(&n->inbuf[ct]),
	       framesize(n->children[i]),framesize((mpeg4_node *)n),
	       n->children[i]->outchan,8);
      ct += n->children[i]->outchan;
    }

    clear_buf(n->outbuf,n->outchan,framesize((mpeg4_node *)n));

    ct = 0;
    
    for (k=0;k!=n->num_whichChoice;k++)
      if (n->whichChoice[k])
      {
	      for (i=0;i!=n->numChan;i++) {
					for (j=0;j!=framesize((mpeg4_node *)n);j++)
						n->outbuf[i][j] += n->inbuf[k][j];
					ct++;
	      }
			}
  }
  break;


  case Sound2D_Node: {
    struct Sound2D *n = (struct Sound2D *)node;

    n->outbuf = buffer(n->outchan,framesize((mpeg4_node *)n));
    
    ac_traverse(n->source);
    
    add_buf(n->source->outbuf,n->outbuf,framesize((mpeg4_node *)n),NULL,n->outchan);
    free_buf(n->source->outbuf,n->outchan);
  }
  break;
  
  case Group_Node: {
    struct Group *n = (struct Group *)node;

    n->outbuf = buffer(n->outchan,framesize((mpeg4_node *)n));
    
    for (i=0;i!=n->num_children;i++) {
      ac_traverse(n->children[i]);
      resample(NULL,(sa_real **)(n->children[i]->outbuf),(sa_real ***)(&n->inbuf_last[i]),
      		(sa_real **)(&n->inbuf[ct]),
	       framesize(n->children[i]),framesize((mpeg4_node *)n),
	       n->children[i]->outchan,8);
      ct += n->children[i]->outchan;
    }
    
    clear_buf(n->outbuf,n->outchan,framesize((mpeg4_node *)n));
    
    /* NB currently ignores any extra channels */
    
    for (i=0;i!=n->outchan;i++)
      for (j=0;j!=framesize((mpeg4_node *)n);j++)
	n->outbuf[i][j] += n->inbuf[i][j] / n->inchan;
  }
  
  break;


// 1/21/2000: for now, same as Group_Node
  case Layer2D_Node: {
    struct Layer2D *n = (struct Layer2D *)node;

    n->outbuf = buffer(n->outchan,framesize((mpeg4_node *)n));
    
    for (i=0;i!=n->num_children;i++) {
      ac_traverse(n->children[i]);
      resample(NULL,(sa_real **)(n->children[i]->outbuf),(sa_real ***)(&n->inbuf_last[i]),
      		(sa_real **)(&n->inbuf[ct]),
	       framesize(n->children[i]),framesize((mpeg4_node *)n),
	       n->children[i]->outchan,8);
      ct += n->children[i]->outchan;
    }
    
    clear_buf(n->outbuf,n->outchan,framesize((mpeg4_node *)n));
    
    /* NB currently ignores any extra channels */
    
    for (i=0;i!=n->outchan;i++)
      for (j=0;j!=framesize((mpeg4_node *)n);j++)
	n->outbuf[i][j] += n->inbuf[i][j] / n->inchan;
  }
  
  break;

  
  case AudioFX_Node: {
    struct AudioFX *n = (struct AudioFX *)node;

    n->outbuf = buffer(n->outchan,framesize((mpeg4_node *)n));
    
    for (i=0;i!=n->num_children;i++) {
      ac_traverse(n->children[i]);
      resample(NULL,(sa_real **)(n->children[i]->outbuf),(sa_real ***)(&n->inbuf_last[i]),
      		(sa_real **)(&n->inbuf[ct]),
	       framesize(n->children[i]),framesize((mpeg4_node *)n),
	       n->children[i]->outchan,8);
      ct += n->children[i]->outchan;
    }
    
    /* complicated buffering since the frame size of the
       AudioFX orchestra ('ksmps' there) may be different from
       the frame size of the decoder.  We know they're at
       the same sampling rate, though. */
    
    /* FXINPT: point we're at in the input cache
       FXOUTPT: point we're at in the output cache */
    ksmps = ((sa_decoder *)n->decoder->priv)->ksmps;
    
    /* first cache the input samples */
    add_buf(n->inbuf,n->fxinbuf,framesize((mpeg4_node *)n),&n->fxinpt,n->inchan);
    
    /* if there's enough to run a frame of the FX decoder */
    while (n->fxinpt >= ksmps) {
      /* then run it */
      sched_run_kcycle((sa_decoder *)n->decoder->priv,n->decoder);
      /* remove those samples from the input cache */
      shift_buf(n->fxinbuf,&n->fxinpt,ksmps,
		n->inchan);
      /* and put them in the output cache */
      add_buf( ((sa_decoder *)n->decoder->priv)->sound ,n->fxoutbuf,
	      ksmps, &n->fxoutpt, n->outchan);
    }
    
    /* if there's enough in the output cache to be the output
       of this mpeg4_node */
    if (n->fxoutpt > framesize((mpeg4_node *)n)) {
      /* copy them there */
      add_buf(n->fxoutbuf,n->outbuf,framesize((mpeg4_node *)n),NULL,n->outchan);
      /* and remove them from the output cache */
      shift_buf(n->fxoutbuf,&n->fxoutpt,framesize((mpeg4_node *)n),n->outchan);
    }
  }
  break;
  }
}

au_list *get_au(decoder *d) { return NULL; }


void decode() {
  decoder *d;
  double new_max;
  comp_buffer *cu;

#ifdef _DEBUG
  printf("ac.c:decode()\n");
#endif
  alldone = 1;
  /* run everybody one frame; then run everybody until they've caught
     up with the decoder with the largest frame */

  for (d=decoders;d;d=d->next) {
    if (!d->done) {
       cu = (*d->run_frame)( d, get_au(d) );
      if (!cu)
				d->time += d->frame;
      else
				d->time =  cu->time + cu->length/(double)d->srate;
    }
    if (d->time > max_decoder_time) max_decoder_time = d->time;
  }

  min_decoder_time = max_decoder_time;
  new_max = max_decoder_time;
  for (d=decoders;d;d=d->next) {
    if (!d->done)
      while (!d->done && d->time < max_decoder_time) {
				cu = (*d->run_frame)( d, get_au(d) );
				if (!cu)
					d->time += d->frame;
				else {
				  d->time = cu->time + cu->length/(double)d->srate;
				  if (d->time > new_max) new_max = d->time;
				}
      }
    if (!d->done) {
      alldone = 0;
      if (d->time < min_decoder_time) min_decoder_time = d->time;
    }
  }
  max_decoder_time = new_max;
}

long gcf(long a, long b) {
  long q, t, u, v;
  u = a;
  v = b;
  while (v) {
    q = u / v;
    t = u - v * q;
    u = v;
    v = t;
  }
  return u;
}

double magic_frame_size() {
  /* the magic frame size is the greatest common
     factor of all the decoder sampling rates, but not too small */
  decoder *d;
  long fact;

  fact = decoders->srate;
  for (d = decoders; d; d = d->next)
    fact = gcf(d->srate,fact);

  while (fact > 50) {
    if (!(fact % 2)) fact /= 2;
    else if (!(fact % 3)) fact /= 3;
    else if (!(fact % 5)) fact /= 5;
  }
  printf("gcf = %ld\n",fact);

  return 1/(double)fact;
}

void cleanup_ac(mpeg4_node *node) {
	switch (node->type) {
		case AudioBuffer_Node: {
    	struct AudioBuffer *n = (struct AudioBuffer *)node;
			free(n->inbuf_last);
		}
		break;	

		case AudioClip_Node: {
    	struct AudioClip *n = (struct AudioClip *)node;
			free_buf(n->clipbuf,n->inchan);
		}
		break;

		case AudioDelay_Node: {
    	struct AudioDelay *n = (struct AudioDelay *)node;
			free(n->inbuf_last);
			free_buf(n->delbuf,n->inchan);
		}
		break;
		
	  case AudioFX_Node: {
	    struct AudioFX *n = (struct AudioFX *)node;
			free(n->inbuf_last);
		}
		break;

	  case AudioMix_Node: {
	    struct AudioMix *n = (struct AudioMix *)node;
			free(n->inbuf_last);
			free_buf(n->inbuf,n->inchan);
		}
		break;

	  case AudioSwitch_Node: {
	    struct AudioSwitch *n = (struct AudioSwitch *)node;
			free(n->inbuf_last);
			free_buf(n->inbuf,n->inchan);
		}
		break;

	  case Group_Node: {
	  	struct Group *n = (struct Group *)node;
			free(n->inbuf_last);
			free_buf(n->inbuf,n->inchan);
		}
		break;

	  case Layer2D_Node: {
	  	struct Layer2D *n = (struct Layer2D *)node;
			free(n->inbuf_last);
			free_buf(n->inbuf,n->inchan);
		}
		break;							
	}	
}


FILE *inf;
 
void main(long argc, char *argv[]) {
  mpeg4_node *node,*sceneheader;
  int hasWorldinfo;
  double stop;
/*  FILE *inf;*/

/* MacOS Change */
#ifdef macintosh
	argc = ccommand( &argv);
#endif


  if (argc < 2) {
    printf("Usage: %s [file]\n",argv[0]);
    exit(1);
  }
  
  if (!(inf = fopen(argv[1],"r"))) {
    printf("Couldn't open scene file '%s'.\n",argv[1]);
    exit(1);
  }

  if (argc > 2) {
    stop = atof(argv[2]);
  } else stop = 0;
  
  unpack(-2, (long)0, inf); /* init */					
  set_field_positions();

#ifdef _DEBUG
  printf("ac.c:main() Field positions set\n");
#endif

  hasWorldinfo = bit(1);

  // 1/21/2000: For now, this shouldn't happen...
  if (hasWorldinfo) {
#ifdef _DEBUG
  printf("Uh oh... we shouldn't be here!\n");
#endif
    sceneheader = parse_node(0); /* SFWorldInfoNodeContext */
  }

  node = parse_node(28);  /* SFTopNodeContext */

#ifdef _DEBUG
  printf("node = %d\n",node);
#endif

  startup_ac(node);
#ifdef _DEBUG
  printf("ac.c:main() past startup_ac()\n");
#endif

  ac_frame_time = magic_frame_size();
  while (!alldone && (!stop || ac_time < stop)) {
    if (ac_time + ac_frame_time < min_decoder_time)
//    if (ac_time < min_decoder_time)
      ac_run(node);
    else
      decode();
    cleanup_cb();
  }
  cleanup_ac(node);
  aifClose(aifout);
}
