#ifndef _ba_h
#define _ba_h

#include "bifs_nodes.h"

/* 
A linked list that associates an internal node type with an internal 
node id. The node id is the 10 bit number stored in the bit stream.          
*/
struct list {
  int id;
  mpeg4_node *node;
  struct list *next;
} *head = NULL, *node = NULL;

struct route_list {
  int id;
  mpeg4_node *out_node, *in_node;
  int out_field, in_field;
  struct route_list *next;
} *route_head = NULL, *route = NULL;


/* Function declarations */
long unpack(int size, char *valueptr, FILE *inf);
long bit(int n);
mpeg4_node *parse_node(int context);
mpeg4_node *new_node();

mask_parse_node(mpeg4_node *the_node);
make_memory(mpeg4_node *the_node, int field, int size);
read_native_MFfield(mpeg4_node *the_node, int field, int index);
list_parse_node(mpeg4_node *the_node);
read_field(mpeg4_node *the_node, int field);
read_native_field(mpeg4_node *the_node, int field);
parse_one_route();

/*extern void swapdouble(double *b);
*/

static int nodeIDbits = 10, routeIDbits = 10;



#endif
