/* ISO_HEADER_START */

/*********************************************************************

  This software module was originally developed by
  
	Eric D. Scheirer (MIT Media Laboratory)
	
  in the course of development of the MPEG-4 standard.
  This software module is an implementation of a part of one or more
  MPEG-4 tools as specified by the MPEG-4 standard.  ISO/IEC gives users
  of the MPEG-4 standard free license to this software module or
  modifications thereof for use in hardware or software products
  claiming conformance to MPEG-4.  Those intending to use this software
  module in hardware or software products are advised that its use may
  infringe existing patents.  The original developer of this software
  module and his/her company, the subsequent editors and their
  companies, and ISO/IEC have no liability for use of this software
  module or modifications thereof in an implementation.  Copyright is
  not released for non MPEG-4 conforming products. The MIT Media
  Laboratory retains full right to use the code for its own purpose,
  assign or donate the code to a third party and to inhibit third
  parties from using the code for non MPEG-4 conforming products.  This
  copyright notice must be included in all copies or derivative
  works. Copyright (c) 1998.
	 
***********************************************************************/

/* ISO_HEADER_END */

#ifndef __BIFS_TYPES_H

#define __BIFS_TYPES_H

typedef char * mpeg4_url;

struct A_2drotation_struct {
	float x,y,theta;
};

typedef char mpeg4_bool;

struct byte_struct {
	char value;
};

typedef 
struct color_struct {
short r,g,b;
} mpeg4_color;

typedef float mpeg4_float;
typedef int mpeg4_int32;

struct node_struct {
	long *ptr;
};

struct objectid_struct {
	short value;
};

typedef struct rotation_struct {
	float x,y,z,theta;
} mpeg4_rotation;

typedef char * mpeg4_string;

/*
typedef struct string_struct {
	char content[1000];
	int length;
} mpeg4_string;
*/

typedef double mpeg4_time;

typedef struct vec2f_struct {
	float x,y;
} mpeg4_vec2f;

typedef struct vec3f_struct {
	float x,y,z;
} mpeg4_vec3f;

#endif

