#! /usr/bin/tcsh -f
# strip-to-mpeg2.sh
#
# remove any source code thats not really part of MPEG-2 AAC Reference Software ..
#
# Ralph Sperschneider, Fraunhofer Institute for Integrated Circuits
# RS 20010328
# RB 20020711
# RS 20021027
#
# usage:
#   ./strip-to-mpeg2.sh
#
mv src src_mpeg4
mv makefile makefile.mpeg4
mkdir src_tmp src

cd src_mpeg4
foreach i ( *.[ch] )
    echo "stripping [key=MPEG4V1] $i";
    ../../general/strip_ifdef key=MPEG4V1 $i >! ../src_tmp/$i
end
cd ../src_tmp
foreach i ( *.[ch] )
    echo "stripping [key=CT_SBR] $i";
    ../../general/strip_ifdef key=CT_SBR $i >! ../src/$i
end
cd ../src
foreach i ( nok_lt_prediction.c nok_lt_prediction.h nok_ltp_common.h nok_ltp_common_internal.h pns.c pns.h mp4dec.c mp4dec.h ct_envcalc.c ct_envcalc.h ct_envdec.c ct_envdec.h ct_envextr.c ct_envextr.h ct_freqsca.c ct_freqsca.h ct_hfgen.c ct_hfgen.h ct_polyphase.c ct_polyphase.h ct_sbrbitb.c ct_sbrbitb.h ct_sbrconst.h ct_sbrcrc.c ct_sbrcrc.h ct_sbrdec.c ct_sbrdec.h ct_sbrdecoder.c ct_sbrdecoder.h )
    echo removing obsolete file $i;
    rm $i
end
cd ..

echo processing makefile
../general/strip_ifdef key=MPEG4V1 makefile.mpeg4 >! makefile

rm -r src_tmp src_mpeg4 makefile.mpeg4

####

mv doc doc_mpeg4
mkdir doc
cd doc_mpeg4
foreach i ( readme* )
    echo "stripping [key=MPEG4V1] $i";
    ../../general/strip_ifdef key=MPEG4V1 $i >! ../doc/$i
end
cd ..
rm -r doc_mpeg4
