#! /usr/bin/tcsh -f
# strip-to-mpeg2.sh
#
# remove any source code thats not really part of MPEG-2 AAC Reference Software ..
#
# Ralph Sperschneider, Fraunhofer Institute for Integrated Circuits
# RS 20010328
# RS 20020711
# RS 20021027
#
# usage:
#   ./strip-to-mpeg2.sh
#
mv src src_mpeg4
mv makefile makefile.mpeg4
mkdir -p src_tmp src

cd src_mpeg4
foreach i ( *.[ch] )
    echo "stripping [key=MPEG4V1] $i";
    ../../general/strip_ifdef key=MPEG4V1 $i >! ../src_tmp/$i
end
cd ../src_tmp
foreach i ( *.[ch] )
    echo "stripping [key=CT_SBR] $i";
    ../../general/strip_ifdef key=CT_SBR $i >! ../src/$i
end
cd ../src
foreach i ( nok_ltp_common.h nok_ltp_common_internal.h nok_ltp_enc.c nok_ltp_enc.h nok_pitch.c nok_pitch.h ct_polyphase.c ct_polyphase.h ct_sbr.c ct_sbr.h )
    echo removing obsolete file $i;
    rm $i
end
cd ..

echo processing makefile
../general/strip_ifdef key=MPEG4V1 makefile.mpeg4 >! makefile

rm -r src_tmp src_mpeg4 makefile.mpeg4
